(: ------------------ transaction join with customer ----------- :)
let $transaction_customer := element set{
  for $in.0 in Source/transactions/transaction
  return
   element tuple {
   element transaction_id  {$in.0/id/text()},
   element	amount  {$in.0/amount/text()},
   element	currency  {$in.0/currency_id/text()},
   element customer_id  {$in.0/customer_id/text()},
   for $in.1 in Source/customers/customer
     where $in.0/customer_id = $in.1/id
   return
     (element	customer_last_name  {$in.1/last_name/text()}, element	customer_first_name  {$in.1/first_name/text()})
   }
    },

 (: ------------------ left join with rate ----------- :)
$transaction_rate_customer := element set{
  for $in.0 in $transaction_customer/tuple
  return
   element tuple {
   element transaction_id  {$in.0/transaction_id/text()},
	 element customer_id  {$in.0/customer_id/text()},
   element	customer_last_name  {$in.0/customer_last_name/text()},
   element	customer_first_name  {$in.0/customer_first_name/text()},
   element currency{$in.0/currency/text()},  
   element amount {fn:round($in.0/amount/text(), 2)},
   for $in.1 in Source/Cubes/Cube
     where $in.0/currency = $in.1/id
   return
      (element currencyRate {$in.1/currency/text()},  element amountRate {fn:round($in.0/amount div $in.1/rate, 2)}) 
    }
}

 (: ------------------ return target ----------- :)

  return(
<target>
<missing_customers>
{    

(: ------------------ return missing customers ----------- :)
for $elem in $transaction_rate_customer/tuple
  where $elem/customer_id = 0
  return
  <missing_customer>
   <transaction_id> {$elem/transaction_id/text()}</transaction_id>
       { 
       if(fn:exists($elem/currencyRate))
          then(<amount>{$elem/amountRate/text()}</amount>, <currency>{$elem/currencyRate/text()}</currency>)
       else(<amount>{$elem/amount/text()}</amount>, <currency>{$elem/currency/text()}</currency>)
      }
   </missing_customer>
}
</missing_customers>
<missing_currencies>
{
   (: ------------------ return missing currency ----------- :)
 for $elem in $transaction_rate_customer/tuple
       where  (($elem/currency/text() = 0 or $elem/currency/text() > 33) and $elem/customer_id/text()  != 0)
  return
  <missing_currency>
        <customer_id>{$elem/customer_id/text()}</customer_id>
       <customer_last_name> {$elem/customer_last_name/text()}</customer_last_name>
        <customer_first_name> {$elem/customer_first_name/text()}</customer_first_name>
        <transaction_id>{$elem/transaction_id/text()}</transaction_id>
        <amount>{$elem/amount/text()}</amount>
        <currency>{$elem/currency/text()}</currency>
   </missing_currency>
}
</missing_currencies>
<risky_customers>
{
  (: ------------------ return risky customers in ascending order ----------- :)    
  for $elem in $transaction_rate_customer/tuple
  let $customer := $elem/customer_id, $customer_last := $elem/customer_last_name, $customer_first := $elem/customer_first_name
  group by $customer, $customer_last, $customer_first
  return 
  if(sum($elem/amountRate) > 400000 ) 
  then
        <risky_customer>
          <customer_id> {  $customer}</customer_id>
          <customer_last_name> {$customer_last}</customer_last_name>
          <customer_first_name> { $customer_first}</customer_first_name>
          <amount>{fn:round(sum($elem/amountRate), 1)}</amount>
          <currency>Euro</currency>
        </risky_customer>
else()
}
</risky_customers>
</target>
)
